#include "../binary_c.h"
No_empty_translation_unit_warning;

#if defined NUCSYN

/*
 * Network code : NeNaMgAl
 * Automatically generated by make_reaction_network_code.pl
 */

/*
 * Species / Reactions list:
 *
 * 1 : H1 : -Ne20*H1*SIGMAV_T20 -Ne21*H1*SIGMAV_T21 -Ne22*H1*SIGMAV_T22 -Na23*H1*SIGMAV_T23 -Na23*H1*SIGMAV_T23P -Mg24*H1*SIGMAV_T24 -Mg25*H1*SIGMAV_T25 -Al26*H1*SIGMAV_T26P -Mg26*H1*SIGMAV_T26 -Al27*H1*SIGMAV_T27 -Al27*H1*SIGMAV_T27a
 * 2 : He4 : +Na23*H1*SIGMAV_T23 +Al27*H1*SIGMAV_T27a
 * 3 : Ne20 : -Ne20*H1*SIGMAV_T20 +Na23*H1*SIGMAV_T23
 * 4 : Ne21 : +Ne20*H1*SIGMAV_T20 -Ne21*H1*SIGMAV_T21
 * 5 : Ne22 : +Ne21*H1*SIGMAV_T21 -Ne22*H1*SIGMAV_T22
 * 6 : Na23 : +Ne22*H1*SIGMAV_T22 -Na23*H1*SIGMAV_T23 -Na23*H1*SIGMAV_T23P
 * 7 : Mg24 : +Na23*H1*SIGMAV_T23P -Mg24*H1*SIGMAV_T24 +Al27*H1*SIGMAV_T27a
 * 8 : Mg25 : +Mg24*H1*SIGMAV_T24 -Mg25*H1*SIGMAV_T25
 * 9 : Mg26 : +Al26*beta*SIGMAV_TBETA26 -Mg26*H1*SIGMAV_T26
 * 10 : Al26 : +Mg25*H1*SIGMAV_T25 -Al26*beta*SIGMAV_TBETA26 -Al26*H1*SIGMAV_T26P
 * 11 : Al27 : +Al26*H1*SIGMAV_T26P +Mg26*H1*SIGMAV_T26 -Al27*H1*SIGMAV_T27 -Al27*H1*SIGMAV_T27a
 * 12 : Si28 : +Al27*H1*SIGMAV_T27
 *
 */
static void NeNaMgAlderivatives_lsoda(double t Maybe_unused,
                                      double * y,
                                      double * dydt,
                                      void * data);

double nucsyn_burn_lsoda_NeNaMgAl(struct stardata_t * Restrict const stardata,
                                  double * Restrict const Nin,
                                  const double * Restrict const sigmav,
                                  const double h)
{
    double err = 0.0;

#define NSPECIES 12

    double yNeNaMgAl[NSPECIES+1];

    yNeNaMgAl[0]=Nin[XH1];
    yNeNaMgAl[1]=Nin[XHe4];
    yNeNaMgAl[2]=Nin[XNe20];
    yNeNaMgAl[3]=Nin[XNe21];
    yNeNaMgAl[4]=Nin[XNe22];
    yNeNaMgAl[5]=Nin[XNa23];
    yNeNaMgAl[6]=Nin[XMg24];
    yNeNaMgAl[7]=Nin[XMg25];
    yNeNaMgAl[8]=Nin[XMg26];
    yNeNaMgAl[9]=Nin[XAl26];
    yNeNaMgAl[10]=Nin[XAl27];
    yNeNaMgAl[11]=Nin[XSi28];

    struct lsoda_t * l = stardata->tmpstore->lsoda;

    if(unlikely(l == NULL))
    {
        /* make lsoda space and set it up */
        stardata->tmpstore->lsoda = Malloc(sizeof(struct lsoda_t));
        l = stardata->tmpstore->lsoda;
        lsoda_setup(l);
    }

    l->Jacobian = NULL;

    /* data passed in to the derivatives function */
    struct lsoda_data_t data;
    data.sigmav = (double*)sigmav;
    data.N = (double*)Nin;

    l->max_steps = INT_MAX; // max number of lsoda steps
    double t = 0.0e0;

    const int istate =
        n_lsoda(l,
                yNeNaMgAl,
                NSPECIES,
                &t,
                h,
                1e-6,
                &NeNaMgAlderivatives_lsoda,
                &data);

    if(istate != 0)
    {
        Exit_binary_c(BINARY_C_NUCSYN_SOLVER_FAILED,
                      "LSODA error (NeNaMgAl) : istate %d\n",
                      istate);
    }

    Nin[XH1]=yNeNaMgAl[0];
    Nin[XHe4]=yNeNaMgAl[1];
    Nin[XNe20]=yNeNaMgAl[2];
    Nin[XNe21]=yNeNaMgAl[3];
    Nin[XNe22]=yNeNaMgAl[4];
    Nin[XNa23]=yNeNaMgAl[5];
    Nin[XMg24]=yNeNaMgAl[6];
    Nin[XMg25]=yNeNaMgAl[7];
    Nin[XMg26]=yNeNaMgAl[8];
    Nin[XAl26]=yNeNaMgAl[9];
    Nin[XAl27]=yNeNaMgAl[10];
    Nin[XSi28]=yNeNaMgAl[11];

    return err;
}


static void NeNaMgAlderivatives_lsoda(double t Maybe_unused,
                                      double * y,
                                      double * dydt,
                                      void * data)
{
    /*
     * When called, should subtract 1 from
     * y and dydt because ppderivatives accesses the
     * arrays with [1] as the first element.
     */
    struct lsoda_data_t * const Restrict lsoda_data =
        (struct lsoda_data_t * const Restrict)data;
    NeNaMgAlderivatives(y-1,
                        dydt-1,
                        (const double * const Restrict) lsoda_data->sigmav,
                        NULL);
}




#endif
